//Sketch principal por Bagur J.
//-------LIBRERIAS------------
#include <LiquidCrystal_I2C.h>
#include <Pushbutton.h>

//--------- LCD -------------
LiquidCrystal_I2C lcd(0x27, 16, 2);

//------- Variables del programa ------
int contador = 1;
int contPausa = 0;
int interrupcion1 = 0;
int interrupcion2 = 1;
volatile int numInterrupcion1   = 0;
volatile int numInterrupcion2   = 1; 
int buttonState = 0; 

//----- Buzzer, RGB y Botones ----
const int Buzzer  = 4;
const int Boton1  = 2;
const int Boton2  = 3;
const int red = 11;
const int green = 10;
const int blue = 9;


//---- Boton para funcion de pausar ------
#define Boton3 5
Pushbutton pbutton1(Boton3); 

//------- Inicializacion general -------
void setup() {
  
  //----- Inicialización de la LCD -----
  lcd.init();
  lcd.backlight();
  lcd.setCursor(0,0);
  lcd.print("Welcome Mr.Stark");
  
  //------- Inicialización del puerto serial --------
  Serial.begin(9600);

  //------- Inicializacion de led RGB -------
  pinMode(red, OUTPUT);
  pinMode(green, OUTPUT);
  pinMode(blue, OUTPUT);
  digitalWrite(red, LOW);
  digitalWrite(green, LOW);
  digitalWrite(blue, LOW);
  
  //-------- Inicialización de Buzzer y botones ----------
  pinMode(Buzzer, OUTPUT);
  pinMode(Boton1, INPUT);
  pinMode(Boton2, INPUT);
  pinMode(Boton3, INPUT);
  
  //----- Inicialización de las interrupciones -----
  attachInterrupt(interrupcion1, funcionInterrupcion1, RISING);
  attachInterrupt(interrupcion2, funcionInterrupcion2, RISING);


}

// ----- Canción 1 ------
int NotasSuperMarioBros    [] = {0, 2637, 2637,    0, 2637,    0, 2093, 2637,    0,
                                 3136,    0,    0,    0, 1568,    0,    0,    0,
                                 2093,    0,    0, 1568,    0,    0, 1319,    0,
                                    0, 1760,    0, 1976,    0, 1865, 1760,    0,
                                 1568, 2637, 3136, 3520,    0, 2794, 3136,
                                    0, 2637,    0, 2093, 2349, 1976,    0,    0,
                                 2093,    0,    0, 1568,    0,    0, 1319,    0,
                                    0, 1760,    0, 1976,    0, 1865, 1760,    0,
                                 1568, 2637, 3136, 3520,    0, 2794, 3136,
                                    0, 2637,    0, 2093, 2349, 1976,    0,    0,};

// ----- tempo cancion 1 -----
int tempoSuperMarioBros [] = {500, 200,  200,  200,  200,  200,  200,  200,  200,
                                  200,  200,  200,  200,  200,  200,  200,  200, 
                                  200,  200,  200,  200,  200,  200,  200,  200, 
                                  200,  200,  200,  200,  200,  200,  200,  200, 
                                  200,  200,  200,  200,  200,  200,  200,   
                                  200,  200,  200,  200,  200,  200,  200,  200,
                                  200,  200,  200,  200,  200,  200,  200,  200, 
                                  200,  200,  200,  200,  200,  200,  200,  200, 
                                  200,  200,  200,  200,  200,  200,  200,   
                                  200,  200,  200,  200,  200,  200,  200,  200,}; 

// ------ Cancion 2 ------
int NotasOcarina      [] = {  0, 261,   0, 294,   0, 294, 311, 183,   0, 261, 222, 190,
                            311, 294, 311, 222, 261,   0, 261,   0, 349, 294,   0, 222, 
                            294, 311, 392,   0, 415, 392, 349, 311, 294, 261,   0};

// ------- tempo Cancion 2 --------
int tempoOcarina   [] = {500, 750, 250, 750, 250, 350, 350, 500, 400, 150, 150, 425, 
                            400, 350, 300, 400, 750, 750, 400, 100, 400, 300, 350, 400, 
                            400, 500, 500, 500, 350, 450, 350, 400, 400, 750, 1000};

// -------- Cancion 3 ---------
int NotasWeRise    [] = {  0, 932,   0, 831,   0, 698,   0, 622,   0, 698,   0, 831, 
                           0, 698,   0, 622,   0, 698,   0, 554,   0, 466,   0,
                         932,   0, 831,   0, 698,   0, 622,   0, 698,   0, 831, 
                           0, 698,   0, 622,   0, 698,   0, 554,   0, 466,   0,
                         554,   0, 622,   0, 554,   0, 622,   0, 698,   0, 698,  
                           0, 554,   0, 622,   0, 554,   0, 622,   0, 698,   0, 
                         698,   0, 554,   0, 622,   0};

// ----- tempo Cancion 3 -----
int tempoWeRise [] = {500, 200,  50, 200,  50, 200,  50, 200,  50, 200,  50, 200,
                          50, 200,  50, 200,  50, 200, 300, 350, 200, 350, 750,
                         200,  50, 200,  50, 200,  50, 200,  50, 200,  50, 200,
                          50, 200,  50, 200,  50, 200, 300, 350, 200, 350, 750,
                         300, 100, 300, 500, 300, 100, 300, 100, 300, 100, 300,
                         200, 300, 100, 300, 500, 300, 100, 300, 100, 300, 100,
                         300, 100, 300, 100, 300, 1000};
                            

//----- Función de interrupción 1 (aumentar el contador) ------
void funcionInterrupcion1() {
  Serial.println("Entro a  la interrupcion 1");
  static unsigned long ultimo_tiempo_de_interrupcion = 0;
  unsigned long tiempo_interrupcion = millis();
  
  if (tiempo_interrupcion - ultimo_tiempo_de_interrupcion > 250) {
    if (contador >= 1 && contador < 3) {
      contador++;
      Serial.print("Contador: ");
      Serial.println(contador);
    }
  }
}
  
//----- Función de interrupción 2 (disminuir el contador) -----
void funcionInterrupcion2() {
  Serial.println("Entro a  la interrupcion 1");
  static unsigned long ultimo_tiempo_de_interrupcion = 0;
  unsigned long tiempo_interrupcion = millis();
  
  if (tiempo_interrupcion - ultimo_tiempo_de_interrupcion > 250) {
    if (contador > 1 && contador <= 3) {
      contador--;
      Serial.print("Contador: ");
      Serial.println(contador);
    }
  }
}

//----- Funcion Pausa ------
void Pausa() {
   if (pbutton1.isPressed()) {
    contPausa = contPausa + 1;
    delay(100); 
    noTone(Buzzer);
    Serial.println("Pausa");
  }
}

//----- Cancion SuperMarioBros ------
void SuperMarioBros() {
  digitalWrite(red, LOW);
  digitalWrite(green, HIGH);
  digitalWrite(blue, LOW);
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Super Mario Bros");
  lcd.setCursor(0,1);
  lcd.print("Koji Kondo");
  Serial.println("Entro a SuperMarioBros");
  for (int i = 0; i <= 78; i++) {
    tone(Buzzer, NotasSuperMarioBros[i]);
    delay(tempoSuperMarioBros[i]);
    
    if (digitalRead(Boton3) == HIGH) {
      noTone(Buzzer);
      Pausa();
      break;
    }
  }
}

// ----- Ocarina ------
void Ocarina() {
  digitalWrite(red, HIGH);
  digitalWrite(green, LOW);
  digitalWrite(blue, HIGH);
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Ocarina");
  lcd.setCursor(0,1);
  lcd.print("D V & L M");
  Serial.println("Entro a Ocarina");
  for (int i = 0; i <= 34; i++) {
    tone(Buzzer, NotasOcarina[i]);
    delay(tempoOcarina[i]);
    
    if (digitalRead(Boton3) == HIGH) {
      noTone(Buzzer);
      Pausa();
      break;
    }
  }
}


void WeRise() {
  digitalWrite(red, HIGH);
  digitalWrite(green, LOW);
  digitalWrite(blue, LOW);
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("We Rise");
  lcd.setCursor(0,1);
  lcd.print("San Holo");
  Serial.println("Entro a Cancion 3");
  for (int i = 0; i <= 72; i++) {
    tone(Buzzer, NotasWeRise[i]);
    delay(tempoWeRise[i]);
    
    if (digitalRead(Boton3) == HIGH) {
      noTone(Buzzer);
      Pausa();
      break;
    }
  }
}

void loop() {
  if (contador == 1) {
    Serial.println("Cancion 1");
    SuperMarioBros();
  } else if (contador == 2) {
    tone(Buzzer, 0, 0);
    Serial.println("Cancion 2");
    Ocarina();
  } else {
    tone(Buzzer, 0, 0);
    Serial.println("Cancion 3");
    WeRise();
  }
}
